;----------------------;
;---Main-Script-Game---;
;----------------------;
Graphics 800, 600, 32, 2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

AppTitle "TimeBack JnR"

Dim Timer(1)

Timer(0) = CreateTimer(60)
Timer(1) = CreateTimer(30)

Include "scripts\game\vars.bb"
Include "scripts\game\types.bb"
Include "scripts\game\buttons.bb"
Include "scripts\game\functions.bb"

;Einstellungen laden
LoadKonfig()

;Ein Bild und n paar Buttons fr das Men
Background1 = LoadImage("gfx\menu_menu.png")
MaskImage Background1, 255, 0, 255

Background2 = LoadImage("gfx\menu_pause.png")
MaskImage Background2, 255, 0, 255

Background3 = LoadImage("gfx\menu_win.png")
MaskImage Background3, 255, 0, 255

Background4 = LoadImage("gfx\menu_gameover.png")
MaskImage Background4, 255, 0, 255

Global ButtonPlay = CreateButton(360, 200, 80, 30, "gfx\buttons\btn_play.png", True)
Global ButtonExit = CreateButton(360, 240, 80, 30, "gfx\buttons\btn_exit.png", True)
Global ButtonMenu = CreateButton(360, 200, 80, 30, "gfx\buttons\btn_menu.png", False)
Global ButtonRepl = CreateButton(360, 240, 80, 30, "gfx\buttons\btn_repl.png", False)

Global ButtonScrB = CreateButton( 20, 360, 33, 33, "gfx\buttons\btn_scrb.png", False)
Global ButtonScrF = CreateButton(747, 360, 33, 33, "gfx\buttons\btn_scrf.png", False)

Global ButtonBack = CreateButton(360, 240, 80, 30, "gfx\buttons\btn_back.png", False)

Global TempMouseX
Global TempMouseY
Global MouseState

Global WorldName$
Global MaxWorldButton

;Lesen wieviele Welten es giebt
Verz = ReadDir("worlds\")
While True
	TempF$ = NextFile(Verz)
	
	If TempF$<>"" Then
		If Right(TempF$, 3)="wdf" Then MaxWorldButton=MaxWorldButton+1
	Else
		Exit
	End If
Wend
CloseDir(Verz)

;Weltbutton erstellen
Dim Button(MaxWorldButton-1)

Verz = ReadDir("worlds\")
While True
	TempF$ = NextFile(Verz)
	
	If TempF$<>"" Then
		If Right(TempF$, 3)="wdf" Then Button(C)=CreateButton(25+C*75+C*25, 263, 75, 75, "gfx\buttons\btn_world.png", False, Left(TempF$, Len(TempF$)-4)):C = C+1
	Else
		Exit
	End If
Wend
CloseDir(Verz)

Fnt = LoadFont("SF Slapstick Comic.ttf", 20)
SetFont Fnt

;Hauptschleife
ClsColor 0, 0, $008CD3
While True
	Cls
	
	;Maus updaten
	TempMouseX = MouseX()
	TempMouseY = MouseY()
	MouseState = 0
	If MouseHit(1) Then MouseState = 1:FlushMouse
	
	TempButtonState = GetClickedButtonID()
	
	;-------------------------------------------------------------;
	
	;berprfung auf welchem Status sich das Spiel gerade befindet
	Select GameState
	Case 1
		DrawImage Background1, 0, 0
		RenderButton()
	Case 2
		RenderButton()
				
		For I=0 To MaxWorldButton-1
			TempB = Button(I)
			Select TempButtonState
			Case TempB
				WorldName$ = GetButtonCap(TempB)
				LoadWorld(WorldName$)
				OpenMenu("GameOver")
				Lives   = 4
				Level   = 0
				Points  = 0
				CurrBUN = 0				
				GameState = 3
			End Select
		Next
	Case 3
		Game()
		If KeyHit(1) Then GameState = 6:OpenMenu("Pause")
	Case 5	
		DrawImage Background4, 0, 0
		RenderButton()
	Case 6
		DrawImage Background2, 0, 0
		RenderButton()
	Case 7
		DrawImage Background3, 0, 0
		RenderButton()
		Text 400, 400, "Beendet in "+Time+"s mit "+Points+" Punkten", True, True
	End Select
	
	;-------------------------------------------------------------;
	
	Select TempButtonState
	Case ButtonPlay
		OpenMenu("Load")
		GameState = 2
	Case ButtonExit
		Exit
	Case ButtonMenu
		OpenMenu("Menu")
		
		GameState = 1
	Case ButtonRepl
		LoadWorld(WorldName$)
		OpenMenu("GameOver")
		
		Lives   = 4
		Level   = 0
		Points  = 0
		CurrBUN = 0
	
		GameState = 3
	Case ButtonScrB
		For I=0 To MaxWorldButton-1
			SetButtonX(Button(I), GetButtonX(Button(I))+75)
		Next	
	Case ButtonScrF
		For I=0 To MaxWorldButton-1
			SetButtonX(Button(I), GetButtonX(Button(I))-75)
		Next
	Case ButtonBack
		If GameState=2 Then OpenMenu("Menu"):GameState=1
		If GameState=6 Then OpenMenu("GameOver"):GameState=3
	End Select
	
	;-------------------------------------------------------------;
	
	If AnyKeyHit() Then FlushKeys
	
	WaitTimer Timer(CurrTimer)
	Flip(0)
Wend

;Alle eintrge nach beenden des Programmes lschen
Delete Each BackUp
Delete Each Enemy
Delete Each Propeller
Delete Each Trap
Delete Each Missile
Delete Each Cannon

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Hauptspiel
Function Game()
	;Sekunden zhlen :D
	If MilliSecs()-999>TimeTimer Then 
		If GoBack=False Then Time = Time+1 Else Time=Time-1
		TimeTimer = MilliSecs()
	End If
	
	;Map und alle anderen Sachen zeichnen
	DrawMap()
	
	RenderPropeller()
	RenderBackUps()
	RenderEnemies()
	RenderPlayer()
	RenderCannons()
	RenderMissiles()
	
	If GoBack=False Then RenderTraps()
		
	;Zeichnet einige Infos auf den Bildschirm
	For I=0 To Lives-1
		DrawImage Info, 20+26*I, 10, 0
	Next
	DrawImage Info, 20, 40, 1
	Text 45, 40+10, Points, False, True
	Rect 20, 181-CurrBUN, 20, CurrBUN
	DrawImage Info, 20, 181-(CurrBUN/2)-11, 2
	Text 45, 181-(CurrBUN/2), "Geladen: "+CurrBUN+"%", False, True
	Text 700, 15, Time
	
	;Wenn die lschtaste gedrckt ist, die Zeit zurck spulen
	If KeyDown(KeyTB) And StopGoBack=False Then
		GoBack = True
		If CurrTimer=0 Then CurrTimer = 1
	Else
		If GoBack And CurrBUN>0 Then Delete Each BackUp:CurrBUN = 0
		If Not KeyDown(KeyTB) Then StopGoBack = False
		If CurrTimer=1 Then CurrTimer = 0
	End If
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function AnyKeyHit()
	For X = 0 To 236
		If KeyHit(X) Then Return True
	Next
End Function

;Ld alle Steuervariablen
Function LoadKonfig()
	FileIn = OpenFile("konfiguration.txt")
	If Not FileIn Then RuntimeError "Erstellen sie eine Konfigurations-Datei!"
	
	While Not Eof(FileIn)
		Select Lower(ReadLine(FileIn))
		Case ";links"
			KeyLe = Int(ReadLine(FileIn))
		Case ";rechts"
			KeyRi = Int(ReadLine(FileIn))
		Case ";hoch"
			KeyUp = Int(ReadLine(FileIn))
		Case ";runter"
			KeyDo = Int(ReadLine(FileIn))
		Case ";springen"
			KeyJu = Int(ReadLine(FileIn))
		Case ";zeit zurckspulen"
			KeyTB = Int(ReadLine(FileIn))
		Case ";nchstes level"
			KeyNext = Int(ReadLine(FileIn))
		End Select
	Wend
	CloseFile FileIn
End Function

;ndern des Menus
Function OpenMenu(S$)
	EnDisableAllButtons(False)
	
	Select S$
	Case "Menu"
		EnDisableButton(ButtonPlay, True)
		EnDisableButton(ButtonExit, True)
	Case "Load"
		For I=0 To MaxWorldButton-1
			EnDisableButton(Button(I), True)
		Next
		
		EnDisableButton(ButtonScrF, True)
		EnDisableButton(ButtonScrB, True)
		
		SetButtonY(ButtonBack, 360)
		EnDisAbleButton(ButtonBack, True)
	Case "GameOver"
		EnDisAbleButton(ButtonMenu, True)
		EnDisAbleButton(ButtonRepl, True)
	Case "Pause"
		SetButtonY(ButtonBack, 240)
	
		EnDisAbleButton(ButtonBack, True)
		EnDisAbleButton(ButtonMenu, True)
	End Select
End Function