Type Window	
	Field ID
	Field X
	Field Y
	Field W
	Field H
	Field Selected
	Field Enabled
	Field Cap$
End Type

Type Label
	Field ID
	Field Owner
	Field X
	Field Y
	Field Cap$
	Field Enabled
End Type

Type ComboBox
	Field ID
	Field Owner
	Field X
	Field Y
	Field W
	Field H
	Field Selected
	Field Cap$
	Field Enabled
End Type

Type ComboBoxItem
	Field ID
	Field Owner
	Field Clicked
	Field Cap$
End Type

Type Button
	Field ID
	Field Owner
	Field X
	Field Y
	Field W
	Field H
	Field Clicked
	Field Cap$
	Field Enabled 
End Type

Type ImageIcon
	Field ID
	Field Owner
	Field Pic
	Field X
	Field Y
	Field W
	Field H
	Field Clicked
	Field Enabled
End Type

Type TextBox
	Field ID
	Field Owner
	Field X
	Field Y
	Field W
	Field H
	Field Selected
	Field Cap$
	Field Enabled
End Type

Type ListBox
	Field ID
	Field Owner
	Field X
	Field Y
	Field W
	Field H
	Field Selected
	Field Rows
	Field ScrY
	Field Increment#
	Field ScrY2#
	Field Childs
	Field Enabled
End Type

Type ListBoxItem
	Field ID
	Field Owner
	Field Selected
	Field Cap$
End Type

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function CreateWindow(Cap$, X, Y, W, H, E)
	Wi.Window = New Window
	
	Wi\ID   = Handle(Wi)
	Wi\X    = X
	Wi\Y    = Y
	Wi\W	= W
	Wi\H    = H
	Wi\Cap$ = Cap$
	
	Wi\Enabled = E
	
	Return Wi\ID
End Function

;--------------------------------------------------------------------;

Function CreateLabel(Cap$, X, Y, Par)
	L.Label = New Label
	
	L\ID 	= Handle(L)
	L\Owner = Par
	L\X		= X
	L\Y		= Y
	L\Cap$	= Cap$
	
	L\Enabled = True	
	
	Return L\ID
End Function

;--------------------------------------------------------------------;

Function CreateComboBox(X, Y, W, H, Par)
	C.ComboBox = New ComboBox
	
	C\ID 	= Handle(C)
	C\Owner = Par
	C\X		= X
	C\Y		= Y
	C\W		= W
	C\H		= H
	
	C\Enabled = True
	
	AddComboBoxItem("", C\ID)
	
	Return C\ID
End Function


Function AddComboBoxItem(Cap$, Par)
	CBI.ComboBoxItem = New ComboBoxItem
	
	CBI\ID 	  = Handle(CBI)
	CBI\Owner = Par
	CBI\Cap$  = Cap$
End Function

;--------------------------------------------------------------------;

Function CreateButton(Cap$, X, Y, W, H, Par)
	B.Button = New Button
	
	B\ID 	= Handle(B)
	B\Owner = Par
	B\X		= X
	B\Y		= Y
	B\W		= W
	B\H 	= H
	B\Cap$  = Cap$
	
	B\Enabled = True
	
	Return B\ID
End Function

;--------------------------------------------------------------------;

Function CreateImageIcon(Pic$, X, Y, W, H, R, G, B, Par)
	IC.ImageIcon = New ImageIcon
	
	IC\ID 	 = Handle(IC)
	IC\Owner = Par
	IC\Pic 	 = LoadImage(Pic$)
	IC\X	 = X
	IC\Y 	 = Y
	IC\W	 = W
	IC\H	 = H
	
	IC\Enabled = True
	
	MaskImage IC\Pic, R, G, B
	
	Return IC\ID
End Function

;--------------------------------------------------------------------;

Function CreateTextBox(X, Y, W, H, Par)
	TB.TextBox = New TextBox
	
	TB\ID	 = Handle(TB)
	TB\Owner = Par
	TB\X	 = X
	TB\Y	 = Y
	TB\W	 = W
	TB\H	 = H
	
	TB\Enabled = True
	
	Return TB\ID
End Function 
;--------------------------------------------------------------------;

Function CreateListBox(X, Y, W, H, Rows, Par)
	L.ListBox = New ListBox
	
	L\ID 	= Handle(L)
	L\Owner = Par
	L\X		= X
	L\Y		= Y
	L\W 	= W
	L\H		= H
	L\Rows  = Rows
	
	L\Enabled = True
	
	Return L\ID 
End Function

Function AddListBoxItem(Cap$, Par)
	LBI.ListBoxItem = New ListBoxItem
	
	LBI\ID 	  = Handle(LBI)
	LBI\Owner = Par
	LBI\Cap$  = Cap$
	
	L.ListBox = Object.ListBox(LBI\Owner)
	L\Childs  = L\Childs+1
	
	If L\Childs>L\Rows Then	L\Increment = (Float(L\H)-45)/(Float(L\Childs)-Float(L\Rows)):L\ScrY = 0:L\ScrY2 = 0
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function RenderWindow()
	For W.Window=Each Window
		If W\Enabled=True Then
			
			;Windowbar zeichnen
			If W\Selected=True Then 
				Color 0, 0, $316AC5
									
			Else
				;Fenster selektieren falls auf die Menbar geklickt wurde
				If RectsOverlap(TempMouseX, TempMouseY, 1, 1, W\X, W\Y-20, W\W, 20) And MouseState=1 Then
					For Wi.Window =Each Window
						If Wi\ID<>W\ID Then Wi\Selected = False
					Next
					
					W\Selected = True
				End If
				
				Color 0, 0, $C3D3ED
			End If
				
			Rect W\X, W\Y-20, W\W, 20, True
			Color 0, 0, $000000
			Rect W\X, W\Y-20, W\W, 20, False
							
			Text W\X+10, W\Y-10, W\Cap$, False, True
			
			;Schlieicon zeichnen
			Color 0, 0, $FF0000
			Text W\X+W\W-15, W\Y-10, "X", False, True
			
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, W\X+W\W-15, W\Y-10, 15, 20) And MouseState=1 Then W\Enabled = False
				
			;Window zeichnen
			Color 0, 0, $D2D2D2
			Rect W\X, W\Y-1, W\W, W\H, True
			
			Color 0, 0, $000000
			Rect W\X, W\Y-1, W\W, W\H, False
			
			;Alle gadjets Rendern
			RenderImageIcons(W\ID, W\X, W\Y)
			RenderLabels	(W\ID, W\X, W\Y)
			RenderTextBoxes (W\ID, W\X, W\Y)
			RenderButtons	(W\ID, W\X, W\Y)
			RenderComboBoxes(W\ID, W\X, W\Y)
			RenderListBoxes (W\ID, W\X, W\Y)
			
		End If
	Next
End Function

;--------------------------------------------------------------------;

Function RenderLabels(Par, ParX, ParY)
	For L.Label=Each Label
		If L\Owner=Par And L\Enabled=True Then
		
			Color 0, 0, $000000
			Text ParX+L\X, ParY+L\Y, L\Cap$
		End If
	Next
End Function

;--------------------------------------------------------------------;

Function RenderComboBoxes(Par, ParX, ParY)
	For C.ComboBox=Each ComboBox
		If C\Owner=Par And C\Enabled=True Then
			
			;Die Box
			Color 0, 0, $FFFFFF
			Rect ParX+C\X, ParY+C\Y, C\W+1, C\H, True
			Color 0, 0, $000000
			Rect ParX+C\X, ParY+C\Y, C\W+1, C\H, False
			
			Text ParX+C\X+15, (ParY+C\Y)+(C\H/2), C\Cap$, False, True
			
			;Der Knopf
			Color 0, 0, $316AC5
			Rect ParX+C\X+C\W, ParY+C\Y, 15, C\H, True
			Color 0, 0, $000000
			Rect ParX+C\X+C\W, ParY+C\Y, 15, C\H, False
			
			;Mausklick
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, ParX+C\X+C\W, ParY+C\Y, 15, C\H) And MouseState=1 Then C\Selected = True-C\Selected
			
			;Wenn die Combobox angeklickt wurde dessen Items anzeigen
			If C\Selected Then RenderComboBoxItems(C\ID, ParX+C\X, ParY+C\Y+C\H, C\W, C\H)
		End If
	Next
End Function
		
Function RenderComboBoxItems(Par, X, Y, W, H)
	Local L
	
	For CBI.ComboBoxItem=Each ComboBoxItem
		If CBI\Owner=Par Then
			Color 0, 0, $FFFFFF
			Rect X, Y+L, W, H, True
			
			Color 0, 0, $000000
			Text X+20, Y+10+L, CBI\Cap$, False, True
			
			;Mausover und Mausklick
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, X, Y+L, W, H) Then
				Rect X, Y+L, W, H, False
				
				If MouseState=1 Then
					Cb.ComboBox = Object.ComboBox(Par)
					Cb\Selected = False
					Cb\Cap$ 	= CBI\Cap$
				End If
			End If
			
			L = L+H
		End If
	Next
End Function

;--------------------------------------------------------------------;

Function RenderButtons(Par, ParX, ParY)
	For B.Button=Each Button
		If B\Owner=Par And B\Enabled=True Then
			
			Color 0, 0, $000000
			Rect ParX+B\X, ParY+B\Y, B\W, B\H, False
			
			Text ParX+B\X+B\W/2, ParY+B\Y+B\H/2, B\Cap$, True, True
			
			Color 0, 0, $646464
			If Not RectsOverlap(TempMouseX, TempMouseY, 1, 1, ParX+B\X, ParY+B\Y, B\W, B\H) Then
				Line ParX+B\X+1, ParY+B\Y+B\H-2, ParX+B\X+B\W-2, ParY+B\Y+B\H-2
				Line ParX+B\X+B\W-2, ParY+B\Y+1, ParX+B\X+B\W-2, ParY+B\Y+B\H-2
			Else
				Line ParX+B\X+1, ParY+B\Y+1, ParX+B\X+B\W-2, ParY+B\Y+1
				Line ParX+B\X+1, ParY+B\Y+1, ParX+B\X+1, ParY+B\Y+B\H-2
				
				;Buttonstate auf geklickt stellen fals der Button an geklickt wurde
				If MouseState=1 Then B\Clicked = True	
			End If
		End If
	Next
End Function
			
;--------------------------------------------------------------------;

Function RenderImageIcons(Par, ParX, ParY)
	For IC.ImageIcon=Each ImageIcon
		If IC\Owner=Par And IC\Enabled=True Then
				
			DrawImage IC\Pic, ParX+IC\X, ParY+IC\Y, 0
			
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, ParX+IC\X, ParY+IC\Y, IC\W, IC\H) And MouseState=1 Then IC\Clicked = True
		End If
	Next
End Function

;--------------------------------------------------------------------;

Function RenderTextBoxes(Par, ParX, ParY)

	For TB.TextBox=Each TextBox
		If TB\Owner=Par And TB\Enabled=True Then
		
			Color 0, 0, $FFFFFF
			Rect ParX+TB\X, ParY+TB\Y, TB\W, TB\H, True
			Color 0, 0, $A2A2A2
			Rect ParX+TB\X+1, ParY+TB\Y+1, TB\W-2, TB\H-2, False
			Color 0, 0, $000000
			Rect ParX+TB\X, ParY+TB\Y, TB\W, TB\H, False
			
			;Damit man schreiben kann :D
			If TB\Selected=True Then
				Text ParX+TB\X+3+StringWidth(TB\Cap$), ParY+TB\Y+(TB\H/2), "_", False, True
				
				Key=GetKey()
				If Key>31 And Key<127 And StringWidth(TB\Cap$)+FontWidth()<TB\W Then TB\Cap$ = TB\Cap$+Chr(Key)
				If Key=8 And TB\Cap$>"" Then TB\Cap$ = Left(TB\Cap$, Len(TB\Cap$)-1)
				FlushKeys
			End If
			
			;Textboxtext anzeigen
			Text ParX+TB\X+3, ParY+TB\Y+(TB\H/2), TB\Cap$, False, True
			
			;Wenn man die Textbox anklickt
			If RectsOverlap(TempMouseX, TempMouseY, 1, 1, ParX+TB\X, ParY+TB\Y, TB\W, TB\H) Then
				If MouseState=1 Then TB\Selected = True
			Else
				If MouseState=1 Then TB\Selected = False
			End If
			
		End If
	Next

End Function

;--------------------------------------------------------------------;

Function RenderListBoxes(Par, ParX, ParY)
	For LB.ListBox=Each ListBox
		If LB\Owner=Par And LB\Enabled=True Then
			
			;Den Hintergrund malen
			Color 0, 0, $FFFFFF
			Rect ParX+LB\X, ParY+LB\Y, LB\W, LB\H, True
			Color 0, 0, $A2A2A2
			Rect ParX+LB\X+1, ParY+LB\Y+1, LB\W-2, LB\H-2, False
			Color 0, 0, $000000
			Rect ParX+LB\X, ParY+LB\Y, LB\W, LB\H, False
			
			;Die Scrollbar malen
			If LB\Childs>LB\Rows Then
				Color 0, 0, $316AC5
				Rect ParX+LB\X+LB\W-1, ParY+LB\Y, 15, 15, True
				Color 0, 0, $000000
				Rect ParX+LB\X+LB\W-1, ParY+LB\Y, 15, 15, False
				
				Color 0, 0, $316AC5
				Rect ParX+LB\X+LB\W-1, ParY+LB\Y+LB\H-15, 15, 15, True
				Color 0, 0, $000000
				Rect ParX+LB\X+LB\W-1, ParY+LB\Y+LB\H-15, 15, 15, False
				
				Line ParX+LB\X+LB\W+15-2, ParY+LB\Y+15, ParX+LB\X+LB\W+15-2, ParY+LB\Y+LB\H-15
				Rect ParX+LB\X+LB\W, ParY+LB\Y+15+LB\ScrY2, 14, 15
				
				;Wenn auf die Scrollbarbuttons geklickt wurde scrollen
				If RectsOverlap(TempMouseX, TempMouseY, 1, 1, ParX+LB\X+LB\W, ParY+LB\Y, 15, 15) And LB\ScrY>0 And MouseState=1 Then LB\ScrY = LB\ScrY-1:LB\ScrY2 = LB\Scry2-LB\Increment
				If RectsOverlap(TempMouseX, TempMouseY, 1, 1, ParX+LB\X+LB\W, ParY+LB\Y+LB\H-15, 15, 15) And LB\ScrY<LB\Childs-LB\Rows And MouseState=1 Then LB\ScrY = LB\ScrY+1:LB\ScrY2 = LB\Scry2+LB\Increment
			End If
			
			RenderListBoxItems(Handle(LB), ParX+LB\X, ParY+LB\Y, LB\W, LB\H, LB\ScrY, LB\Rows)
		End If
	Next
End Function

Function RenderListBoxItems(Par, X, Y, W, H, ScrY, Rows)
	Local C

	For LBI.ListBoxItem=Each ListBoxItem
		If LBI\Owner=Par Then  			
					
			If C-ScrY>-1 And C-ScrY<Rows Then 
			
				If RectsOverlap(TempMouseX, TempMouseY, 1, 1, X+1, Y+10+C*15-ScrY*15, W-2, 15) Then
					Color 0, 0, $C3D3ED
					Rect X+1, Y+5+C*15-ScrY*15, W-2, 15, True
					Color 0, 0, $316AC5
					Rect X+1, Y+5+C*15-ScrY*15, W-2, 15, False
					
					If MouseState=1 Then 
						For LBIt.ListBoxItem=Each ListboxItem
							LBIt\Selected = False
						Next
						
						LBI\Selected=True
					End If
				End If
				
				If LBI\Selected=True Then 
					Color 0, 0, $C3D3ED
					Rect X+1, Y+5+C*15-ScrY*15, W-2, 15, True
					Color 0, 0, $316AC5
					Rect X+1, Y+5+C*15-ScrY*15, W-2, 15, False
				End If
			
				Color 0, 0, $000000	
				Text X+10, Y+5+C*15-ScrY*15, LBI\Cap$
				
			End If
			
			C = C+1
		End If
	Next
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Zum ausschalten oder anschalten verschiedener Elemente
Function EnDisableGadjet(ID, E)
	Wi.Window = Object.Window(ID)
	If Wi<>Null Then Wi\Enabled = E:Return
	
	L.Label = Object.Label(ID)
	If L<>Null Then L\Enabled = E:Return
	
	CBX.ComboBox = Object.ComboBox(ID)
	If CBX<>Null Then CBX\Enabled = E:Return
	
	B.Button = Object.Button(ID)
	If B<>Null Then B\Enabled = E:Return
	
	IC.ImageIcon = Object.ImageIcon(ID)
	If IC<>Null Then IC\Enabled = E:Return
	
	TB.TextBox = Object.TextBox(ID)
	If TB<>Null Then TB\Enabled = E:Return
	
	LB.ListBox = Object.ListBox(ID)
	If LB<>Null Then LB\Enabled = E:Return
End Function

;Schaltet jedes Gadjet aus
Function EnDisableAllGadjets(E)
	For L.Label=Each Label
		L\Enabled = E
	Next
	For CBX.ComboBox=Each ComboBox
		CBX\Enabled = E
	Next
	For B.Button=Each Button
		B\Enabled = E
	Next
	For IC.ImageIcon=Each ImageIcon
		IC\Enabled = E
	Next
	For TB.TextBox=Each TextBox
		TB\Enabled = E
	Next
	For LB.ListBox=Each ListBox
		LB\Enabled = E
	Next
End Function

;--------------------------------------------------------------------;

;berprft ob irgendein Fenster aktiv ist
Function WindowAktiv()
	For W.Window=Each Window
		If W\Enabled=True Then Return True
	Next
	
	Return False
End Function

Function SetWindowTitel(ID, T$)
	W.Window = Object.Window(ID)
	W\Cap$ = T$
End Function

;--------------------------------------------------------------------;

;berprft ob ein Element geklickt wurde oder ob die Maus darber ist etc.
Function GetEvents(S$)
	Select S$
	Case "BUTTON"
		For Bu.Button=Each Button
			If Bu\Clicked=True Then Bu\Clicked=False:Return Bu\ID
		Next
	Case "IMAGEICON"
		For ImC.ImageIcon=Each ImageIcon
			If ImC\Clicked = True Then ImC\Clicked = False:Return ImC\ID
		Next
	End Select
End Function

;--------------------------------------------------------------------;

Function GetComboBoxText$(C)
	Co.ComboBox = Object.ComboBox(C)
	Return Co\Cap$
End Function

Function SetComboBoxText(C, Cap$)
	Co.ComboBox = Object.ComboBox(C)
	Co\Cap$		= Cap$
End Function

;-------------------------------;

Function DeleteComboBoxItem(Cap$, Par)
	For CBI.ComboBoxItem = Each ComboBoxItem
		If CBI\Cap$=Cap$ And CBI\Owner=Par Then Delete CBI
	Next
End Function

;--------------------------------------------------------------------;

Function GetLabelText$(L)
	La.Label = Object.Label(L)
	Return La\Cap$
End Function

Function SetLabelText(L, Cap$)
	La.Label = Object.Label(L)
	La\Cap$  = Cap$
End Function

;--------------------------------------------------------------------;

Function GetImageIconPic(IC)
	ImC.ImageIcon = Object.ImageIcon(IC)
	Return ImC\Pic
End Function

Function SetImageIconPic(IC, Pic, R, G, B)
	ImC.ImageIcon = Object.ImageIcon(IC)
	FreeImage ImC\Pic
	
	ImC\Pic = LoadImage(Pic)
	MaskImage ImC\Pic, R, G, B
End Function

;--------------------------------------------------------------------;

Function GetTextBoxText$(TB)
	TBo.TextBox = Object.TextBox(TB)
	Return TBo\Cap$
End Function

Function SetTextBoxText(TB, Cap$)
	TBo.TextBox = Object.TextBox(TB)
	TBo\Cap$ = Cap$
End Function

;--------------------------------------------------------------------;

Function GetListBoxItemNumber(ID)
	LB.ListBox = Object.ListBox(ID)
	Return LB\Childs
End Function

Function GetSelectedListBoxItem$(Par)
	For LBI.ListBoxItem=Each ListBoxItem
		If LBI\Selected=True And LBI\Owner=Par Then Return LBI\Cap$
	Next
End Function

Function GetListBoxItemByIndex$(I, Par)
	For LBI.ListBoxItem=Each ListBoxItem
		If LBI\Owner=Par Then
			If C=I Then Return LBI\Cap$
			C = C+1
		End If	
	Next
End Function

;Lscht ein Listboxitem mit angegebenen String
Function DeleteListBoxItem(Cap$, Par)
	For LBI.ListBoxItem=Each ListBoxItem
		If LBI\Cap$=Cap$ And LBI\Owner=Par And LBI\Selected=True Then 
			LB.ListBox = Object.ListBox(LBI\Owner)
			LB\Childs  = LB\Childs-1
			
			If LB\Childs>LB\Rows Then LB\Increment = (Float(LB\H)-45)/(Float(LB\Childs)-Float(LB\Rows)):LB\ScrY = 0:LB\ScrY2 = 0
			
			Delete LBI
		End If
	Next
End Function

;Lscht ein Listboxitem der mit dem Index bereinstimmt
Function DeleteListboxItemByIndex(I, Par)
	For LBI.ListBoxItem=Each ListBoxItem
		If LBI\Owner=Par Then 
			If C=I Then	Delete LBI
			C = C+1
		End If
	Next
End Function

;Schaut ob ein String in einer Listbox enthalten ist
Function IsStringItemOfListBox(S$, Par)
	For LBI.ListBoxItem=Each ListBoxItem
		If LBI\Owner=Par And LBI\Cap$=S$ Then DebugLog "Enthalten":Return True		
	Next
	
	DebugLog "Nicht enthalten"
	Return False
End Function
;--------------------------------------------------------------------;

Function FreeGui()
	Delete Each Window
	Delete Each Label
	Delete Each ComboBox
	Delete Each ComboBoxItem
	Delete Each Button
	Delete Each ImageIcon
	Delete Each TextBox
	Delete Each ListBox
	Delete Each ListBoxItem
End Function