;------------------------;
;--Funktionen vom Spiel--;
;------------------------;

Dim World$(1)
Dim Map(MapMaxX, MapMaxY, 1)
Dim Propeller(3)

;----------------------------------------------------------------------------------------------------------------------------------------------;

Function LoadWorld(F$)
	FileIn = OpenFile("worlds\"+F$+".wdf")
	
	MaxLevel = ReadInt(FileIn)
	Dim World$(MaxLevel)
	
	For I=0 To MaxLevel
		World$(I) = ReadString(FileIn)
	Next
	
	CloseFile FileIn
	
	LoadMap(World$(0))
	
	TimeTimer = MilliSecs()
	Time = 0
End Function

Function LoadMap(FileIn$)	
	;Delete Each BackUp
	Delete Each Enemy
	Delete Each Propeller
	Delete Each Trap
	Delete Each Missile
	Delete Each Cannon
	
	CurrBUN = 0
	
	FileIn = OpenFile("worlds\maps\"+FileIn$)
	
	;Tileset laden
	Ts = ReadByte(FileIn)	
	FreeImage Tileset
	
	Tileset = LoadAnimImage("gfx\tilesets\tileset"+Ts+"\tileset.png", 32, 32, 0, 16)
	MaskImage Tileset, 255, 0, 255
	
	LoadAnims(Ts)
	
	;Map dimensionieren
	MapMaxX = ReadByte(FileIn)
	MapMaxY = ReadByte(FileIn)
	Dim Map(MapMaxX, MapMaxY, 1)
	
	PlayerX = ReadByte(FileIn)*32
	PlayerY = ReadByte(FileIn)*32-17
	
	FinishX = ReadByte(FileIn)*32
	FinishY = ReadByte(FileIn)*32
	
	For Y=0 To MapMaxY
		For X=0 To MapMaxX
			TempByte = ReadByte(FileIn)
			
			If TempByte<13 Then
				Map(X, Y, 0) = TempByte
				
				;Fallen erstellen
				If TempByte=10 Then
					T.Trap = New Trap
					T\X	   = X
					T\Y	   = Y
					T\SDelay = Rand(300, 500)
					T\Timer=T\SDelay
				End If
				
				If TempByte=6 Or TempByte=7 Then
					C.Cannon = New Cannon 
					C\X		 = X
					C\Y 	 = Y
					C\D 	 = TempByte-6
				End If
			Else If TempByte<17 Then
				
				;Propeller erstellen
				P.Propeller = New Propeller
				P\X = X
				P\Y = Y
				P\Dir = TempByte-13
				P\Frame = 0
				P\FTimer = 6
				
				Map(X, Y, 0) = 0
			Else				
				E.Enemy = New Enemy
				E\X		= X*32
				E\Y		= Y*32
				E\D		= Rand(0, 1)
				E\T		= TempByte-17
				
				If TempByte<19 Then 
					Map(X, Y, 0) = 0
				Else
					Map(X, Y, 0) = 2
				End If
			End If
			
			;Kollisionslayer laden
			Map(X, Y, 1) = ReadByte(FileIn)
		Next
	Next
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Ld alle Tileset-Bilder
Function LoadAnims(O)
	For I=0 To 3
		If Propeller(I) Then FreeImage(Propeller(I))
	Next
	
	If WhirlWind1 Then FreeImage WhirlWind1
	If WhirlWind2 Then FreeImage WhirlWind2
	
	;Propeller animation laden
	Propeller(0) = LoadAnimImage("gfx\tilesets\tileset"+O+"\propeller1.png", 32, 32, 0, 3)
	MaskImage Propeller(0), 255, 0, 255
	Propeller(1) = LoadAnimImage("gfx\tilesets\tileset"+O+"\propeller2.png", 32, 32, 0, 3)
	MaskImage Propeller(1), 255, 0, 255
	Propeller(2) = LoadAnimImage("gfx\tilesets\tileset"+O+"\propeller3.png", 32, 32, 0, 3)
	MaskImage Propeller(2), 255, 0, 255
	Propeller(3) = LoadAnimImage("gfx\tilesets\tileset"+O+"\propeller4.png", 32, 32, 0, 3)
	MaskImage Propeller(3), 255, 0, 255
	
	;Wirbelwind animation laden
	WhirlWind1 = LoadAnimImage("gfx\tilesets\tileset"+O+"\whirlwind1.png", 96, 32, 0, 6)
	MaskImage WhirlWind1, 255, 0, 255
	
	WhirlWind2 = LoadAnimImage("gfx\tilesets\tileset"+O+"\whirlwind2.png", 32, 96, 0, 6)
	MaskImage WhirlWind2, 255, 0, 255
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Zeichnet die Map
Function DrawMap()
	Local CamXs = ScrX/32
	Local CamXe = CamXs+25
	
	Local CamYs = ScrY/32
	Local CamYe = CamYs+19
	
	If CamXe>MapMaxX Then CamXe = MapMaxX
	If CamYe>MapMaxY Then CamYe = MapMaxY
	
	For Y=CamYs To CamYe
		For X=CamXs To CamXe
			If Map(X, Y, 0)>0 Then DrawImage Tileset, X*32-ScrX, Y*32-ScrY, Map(X, Y, 0)-1
		Next
	Next
	
	;Das Ziel malen :D
	DrawImage TileSet, FinishX-ScrX, FinishY-ScrY, 11
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Zeichnet alle animierten Propeller
Function RenderPropeller()
	For P.Propeller = Each Propeller
		
		;Propeller animieren
		P\FTimer = P\FTimer-1
		If P\FTimer = 0 Then 
			P\FTimer = 6
			
			If P\Frame<2 Then
				P\Frame = P\Frame+1
			Else
				P\Frame = 0
			End If
		End If
		
		;Propeller und Strme zeichnen und die jeweiligen Aktionen mit dem Spieler ausfhren
		If P\X*32-ScrX>0 And P\X*32-ScrX<801 And P\Y*32-ScrY>0 And P\Y*32-ScrY<601 Then 
			DrawImage Propeller(P\Dir), P\X*32-ScrX, P\Y*32-ScrY, P\Frame
			
			Select P\Dir
			Case 0
				DrawImage WhirlWind2, P\X*32-ScrX-4, P\Y*32-ScrY-96+25, P\Frame
				
				If RectsOverlap(PlayerX, PlayerY-17, 25, 49, P\X*32, P\Y*32-70, 32, 95) Then
					If OnPropeller=False Then OnPropeller = True
					If Jump = False Then
						;Spieler hoch bewegen
						If Map((PlayerX+20)/32, (PlayerY-19)/32, 1)=0 And Map((PlayerX+4)/32, (PlayerY-19)/32, 1)=0 Then PlayerY = PlayerY-1
					Else
						;Fall dmpfen
						JumpHigh# = JumpHigh#+2.5
						If JumpHigh>=0 Then Jump = False
					End If
				End If
			Case 1	
				DrawImage WhirlWind1, P\X*32-ScrX+4, P\Y*32-ScrY+3, P\Frame
								
				;Sobald der Spieler in den Wirbel kommt
				If RectsOverlap(PlayerX, PlayerY-17, 25, 49, P\X*32+5, P\Y*32, 95, 32) Then
					
					;Falls Pfeil Links XSpeed erhhen um so nen Boost zu bekommen ihn sonst einfach vorwrts bewegen:D
					If KeyDown(KeyLe) And KeyDown(KeyRi)=False Then 
						PlayerXSpeed# = PlayerXSpeed#+0.5
					Else 
						PlayerXSpeed# = 0
						If Map((PlayerX+25)/32, (PlayerY-17)/32, 1)=0 And Map((PlayerX+25)/32, (PlayerY+8)/32, 1)=0 And Map((PlayerX+25)/32, (PlayerY+31)/32, 1)=0 Then PlayerX = PlayerX+2
					End If
					
					;Oder wenn der Spieler gerade mit karacho drauf fliegt ihn dmpfen
					If KeyDown(KeyRi) And PlayerXSpeed<0 Then PlayerXSpeed = PlayerXSpeed-0.5
				End If
			Case 2
				DrawImage WhirlWind2, P\X*32-ScrX-25, P\Y*32-ScrY+4, 2+P\Frame
				
				If RectsOverlap(PlayerX, PlayerY-17, 25, 49, P\X*32, P\Y*32+4, 32, 95) Then
					If Jump = False Then
						;Spieler runter bewegen
						If Map((PlayerX+20)/32, (PlayerY+33)/32, 1)=0 And Map((PlayerX+4)/32, (PlayerY+33)/32, 1)=0 Then PlayerY = PlayerY+1
					Else
						;Hochsprung dmpfen 
						JumpHigh# = JumpHigh#-2.5
						;If JumpHigh<=0 Then Jump = False
					End If
				End If
			Case 3
				DrawImage WhirlWind1, P\X*32-ScrX+25-96, P\Y*32-ScrY+3, 3+P\Frame
				
				If RectsOverlap(PlayerX, PlayerY-17, 25, 49, P\X*32-91, P\Y*32, 95, 32) Then
					
					;Hier muss verringert werden da er ja zurck geboostet wird :D
					If KeyDown(KeyRi) And KeyDown(KeyLe)=False Then 
						PlayerXSpeed# = PlayerXSpeed#-0.5
					Else 
						PlayerXSpeed# = 0
						If Map((PlayerX-1)/32, (PlayerY-17)/32, 1)=0 And Map((PlayerX-1)/32, (PlayerY+8)/32, 1)=0 And Map((PlayerX-1)/32, (PlayerY+31)/32, 1)=0 Then PlayerX = PlayerX-2
					End If
					
					If KeyDown(KeyLe) And PlayerXSpeed>0 Then PlayerXSpeed = PlayerXSpeed-0.5					
				End If		
			End Select
		End If
	Next
End Function

;------------------------------------------------------------------------;

;Bentigt um zu schauen ob der spieler auf keinem Propeller ist
Function PlayerIsOnNoProp()
	For P.Propeller = Each Propeller
		If RectsOverlap(PlayerX, PlayerY-17, 25, 49, P\X*32, P\Y*32-71, 32, 96) And P\Dir=0 Then Return False
	Next
	
	Return True
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Die Kanonen sollen ja auch schieen wenn der Spieler in der Nhe ist :D
Function RenderCannons()
	For C.Cannon = Each Cannon
		If C\ShotTimer=0 And GoBack=False Then
			
			;Richtung auswhlen
			Select C\D
			Case 0
				If RectsOverlap(PlayerX, PlayerY-17, 25, 49, C\X*32-200, C\Y*32, 200, 32) Then 
					C\ShotTimer = 130
					CreateShot(C\X*32, C\Y*32+20, -1, 1)
				End If
			Case 1
				If RectsOverlap(PlayerX, PlayerY-17, 25, 49, C\X*32+32, C\Y*32, 200, 32) Then 
					C\ShotTimer = 130
					CreateShot(C\X*32+32, C\Y*32+20, 1, 1)
				End If
			End Select
		Else
			;Den Timer bei normaler Zeit verringern sonst erhhen
			If GoBack=False Then 
				C\ShotTimer = C\ShotTimer-1 
			Else 
				C\ShotTimer = C\ShotTimer+1
				If C\ShotTimer>130 Then C\ShotTimer = 0
			End If
		End If
	Next
End Function

;------------------------------------------------------------------------;

;Macht, dass die Fallen Steine spucken
Function RenderTraps()
	For T.Trap=Each Trap
		If GoBack=False Then
			T\Timer = T\Timer-1
		Else
			If T\Timer<T\SDelay Then T\Timer = T\SDelay Else T\Timer = 0
		End If
		
		If T\Timer=0 Then CreateShot(T\X*32, T\Y*32, 1, 2):T\Timer = T\SDelay
	Next
End Function

;------------------------------------------------------------------------;

;Alle Gegner
Function RenderEnemies()
	For E.Enemy = Each Enemy
		Select E\T
		Case 0
			If E\X-ScrX-8>0 And E\X-ScrX-8<800 And E\Y-ScrY+10>0 And E\Y-ScrY+10<600 Then DrawImage SnailPng, E\X-ScrX-8, E\Y-ScrY+10, E\D
			
			;Links und Rechts-Bewegung
			Select E\D
			Case 0 
				If GoBack = False Then
					If E\X-1>0 And Map((E\X-1)/32, (E\Y+16)/32, 1)=0 And Map(E\X/32, (E\Y+33)/32, 1)=1 Then E\X = E\X-1 Else E\D = 1
				Else
				    If E\X+51<MapMaxX*32 And Map((E\X+51)/32, (E\Y+16)/32, 1)=0 And Map((E\X+50)/32, (E\Y+33)/32, 1)=1 Then E\X = E\X+1 Else E\D = 1
				End If
			Case 1
				If GoBack = False Then
					If E\X+51<MapMaxX*32 And Map((E\X+51)/32, (E\Y+16)/32, 1)=0 And Map((E\X+50)/32, (E\Y+33)/32, 1)=1 Then E\X = E\X+1 Else E\D = 0
				Else
					If E\X-1>0 And Map((E\X-1)/32, (E\Y+16)/32, 1)=0 And Map(E\X/32, (E\Y+33)/32, 1)=1 Then	E\X = E\X-1 Else E\D = 0
				End If
			End Select
								
			;Auf berhrung mit dem Spieler reagieren
			If RectsOverlap(E\X, E\Y+8, 50, 22, PlayerX, PlayerY-17, 25, 49) And Hit=False And GoBack=False Then
				
				;Wenn der Spieler drauf gesprungen ist, lschen und einen Eintrag in der Typeliste erstellen, sonst Leben abziehen
				If Jump=True And JumpHigh#<=0 Then
					B.BackUp = Last BackUp
					B\EnemyX = E\X
					B\EnemyY = E\Y
					B\EnemyD = E\D
					B\EnemyT = 3	
					
					Delete E
					
					Points = Points+5
					JumpHigh# = 5
				Else
					Hit = True
					Lives = Lives-1
				End If
			End If
		Case 1
			If E\X-ScrX-8>0 And E\X-ScrX-8<800 And E\Y-ScrY+10>0 And E\Y-ScrY+10<600 Then DrawImage TurtelPng, E\X-ScrX-8, E\Y-ScrY+10, E\D+E\Frame
			
			;Fr Animation sorgen :D
			E\FrameTimer = E\FrameTimer-1
			If E\FrameTimer<=0 Then
				E\FrameTimer = 5
				If GoBack=False Then E\Frame = E\Frame+1 Else E\Frame = E\Frame-1
			End If			
			
			;Bewegung der Schildkrte
			Select E\D
			Case 0 				
				If GoBack = False Then
					If E\Frame>3 Then E\Frame=0
					If E\X-1>0 And Map((E\X-1)/32, (E\Y+16)/32, 1)=0 And Map(E\X/32, (E\Y+33)/32, 1)=1 And Map(E\X/32, (E\Y+33)/32, 0)<>11 Then E\X = E\X-1 Else E\D = 1
				Else
					If E\Frame<0 Then E\Frame=3
					If E\X+72<MapMaxX*32 And Map((E\X+71)/32, (E\Y+16)/32, 1)=0 And Map((E\X+70)/32, (E\Y+33)/32, 1)=1 And Map((E\X+70)/32, (E\Y+33)/32, 0)<>11 Then E\X = E\X+1 Else E\D = 1				
				End If
			Case 1			
				If GoBack = False Then
					If E\Frame>6 Then E\Frame=4
					If E\X+72<MapMaxX*32 And Map((E\X+71)/32, (E\Y+16)/32, 1)=0 And Map((E\X+70)/32, (E\Y+33)/32, 1)=1 And Map((E\X+70)/32, (E\Y+33)/32, 0)<>11 Then E\X = E\X+1 Else E\D = 0
				Else
					If E\Frame<4 Then E\Frame=6
					If E\X-1>0 And Map((E\X-1)/32, (E\Y+16)/32, 1)=0 And Map(E\X/32, (E\Y+33)/32, 1)=1 And Map(E\X/32, (E\Y+33)/32, 0)<>11 Then E\X = E\X-1 Else E\D = 0
				End If
			End Select
					
			;Auf berhrung mit dem Spieler reagieren (Nur Leben abziehen)
			If RectsOverlap(E\X, E\Y+10, 71, 33, PlayerX, PlayerY-17, 25, 49) And Hit=False And GoBack=False Then Hit = True:Lives = Lives-1
		Case 2
		
			;Wenn der Spieler ein Scheintile berhrt es verschwinden lassen sonst wieder erscheinen lassen
			If RectsOverlap(E\X, E\Y-1, 32, 34, PlayerX, PlayerY-17, 25, 49) Then
				Map(E\X/32, E\Y/32, 0) = 0
				Map(E\X/32, E\Y/32, 1) = 0
			Else
				If Map(E\X/32, E\Y/32, 0) = 0 And Map(E\X/32, E\Y/32, 0) = 0 Then
					Map(E\X/32, E\Y/32, 0) = 2
					Map(E\X/32, E\Y/32, 1) = 1
				End If
			End If
		End Select
	Next
End Function
;------------------------------------------------------------------------;

;Erstellt einen Shuss
Function CreateShot(X, Y, Dir,T)
	M.Missile = New Missile
	
	M\X = X
	M\Y = Y
	M\D = Dir
	M\T = T
End Function

;------------------------------------;

;Fhrt die Bewegung etc. der Flugkrper durch 
Function RenderMissiles()
	Local CreateBackUp

	For M.Missile=Each Missile
		If M\T=1 Then 
			DrawImage CannonBallPng, M\X-ScrX, M\Y-ScrY
			
			;Rechts oder links bewegen
			If GoBack=True Then
				M\X = M\X-M\D*4
			Else
				M\X = M\X+M\D*4
			End If
			
			;Wenn die Kanonenkugel den sichtbaren Bereich unter/berschreitet sie lschen
			If GoBack=False Then
				If (M\X-ScrX<=0 Or M\X-ScrX>=800 Or RectsOverlap(M\X, M\Y, 10, 10, PlayerX, PlayerY-17, 25, 49)) Then
					;Wenn der Spieler berhrt wurde diesem ein Leben abziehen
					If Hit=False And RectsOverlap(M\X, M\Y, 10, 10, PlayerX, PlayerY-17, 25, 49) Then Hit = True:Lives = Lives-1
					CreateBackUp = True
				End If
			End If
		Else If M\T=2 Then
			Oval M\X-ScrX, M\Y-ScrY, 20, 20
			
			;Hoch oder runter bewegen
			If GoBack=True Then
				M\Y = M\Y-M\D*7
			Else
				M\Y = M\Y+M\D*7
			End If
			
			;Wenn der Stein den sichtbaren Bereich unter/berschreitet oder gegen ein Kollisionstile trifft ihn lschen
			If GoBack=False Then
				If (M\X<=0 Or M\X+30>MapMaxX*32 Or RectsOverlap(M\X, M\Y, 20, 20, PlayerX, PlayerY-17, 25, 49) Or Map((M\X+10)/32, (M\Y+21)/32, 1)=1) Then
					If Hit=False And RectsOverlap(M\X, M\Y, 20, 20, PlayerX, PlayerY-17, 25, 49) Then Hit = True:Lives = Lives-2
					CreateBackUp = True
				End If
			End If
		End If	
		
		;Hier werden Backups erstellt :D
		If CreateBackUp=True Then
			;BackUp der Kugel erstellen um es beim Zurckspulen wieder herzustellen
			B.BackUp = Last BackUp
				
			;Wenn der letzte Eintrag bereits Daten enthlt einen neuen erstellen
			If B\EnemyX=0 And B\EnemyY=0 And B\EnemyT=0 Then
				B\EnemyX = M\X
				B\EnemyY = M\Y
				B\EnemyD = M\D
				B\EnemyT = M\T
			Else
				Ba.BackUp = New BackUp
				Ba\EnemyX = M\X
				Ba\EnemyY = M\Y
				Ba\EnemyD = M\D
				Ba\EnemyT = M\T
			End If
			
			Delete M
			Deleted = True
			CreateBackUp = False
		End If
		
		;Falls das "Geschoss" beim Zurckspulen seinen Ursprung erreicht lschen
		If GoBack=True Then
			If Deleted=False Then
				For C.Cannon = Each Cannon
					If RectsOverlap(M\X, M\Y, 1, 1, C\X*32, C\Y*32, 32, 32) Then Delete M:Deleted=True:Exit
				Next
			End If
			
			If Deleted=False Then 
				For T.Trap = Each Trap
					If RectsOverlap(M\X, M\Y, 1, 1, T\X*32, T\Y*32, 32, 4) Then Delete M:Exit
				Next
			End If
		End If
	Next
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;Spieler wird geupdated
Function RenderPlayer()

	If GoBack=False Then
		;Leitern benutzbar machen
		If Map((PlayerX+16)/32, (PlayerY+31)/32, 0)=8 Or Map((PlayerX+16)/32, (PlayerY+32)/32, 0)=8 Then
			If KeyDown(KeyUp) And Map((PlayerX+20)/32, (PlayerY-18)/32, 1)=0 And Map((PlayerX+4)/32, (PlayerY-18)/32, 1)=0 Then 
				PlayerY    = PlayerY-2
				FrameTimer = FrameTimer-1
				If FrameTimer<=0 Then PlayerFrame = PlayerFrame+1:FrameTimer=20
			End If
			
			If KeyDown(KeyDo) And Map((PlayerX+20)/32, (PlayerY+32)/32, 1)=0 And Map((PlayerX+4)/32, (PlayerY+32)/32, 1)=0 Then 
				PlayerY    = PlayerY+2
				FrameTimer = FrameTimer-1
				If FrameTimer<=0 Then PlayerFrame = PlayerFrame-1:FrameTimer=20				
			End If
			
			If PlayerFrame<2 Then PlayerFrame=3
			If PlayerFrame>3 Then PlayerFrame=2
		End If
		
		;Links und rechts laufen
		If KeyDown(KeyRi) And Map((PlayerX- 1)/32, (PlayerY+31)/32, 1)=0 And Map((PlayerX- 1)/32, (PlayerY-17)/32, 1)=0 And Map((PlayerX- 1)/32, (PlayerY+8)/32, 1)=0 Then
			If PlayerXSpeed#>0 Then PlayerXSpeed#=0
			If PlayerX-5>0 Then	PlayerX = PlayerX-5+PlayerXSpeed#:PlayerFrame = 1
		End If
		
		If KeyDown(KeyLe) And Map((PlayerX+25)/32, (PlayerY+31)/32, 1)=0 And Map((PlayerX+25)/32, (PlayerY-17)/32, 1)=0 And Map((PlayerX+25)/32, (PlayerY+8)/32, 1)=0 Then
			If PlayerXSpeed#<0 Then PlayerXSpeed#=0
			If PlayerX+5<MapMaxX*32 Then PlayerX = PlayerX+5+PlayerXSpeed#:PlayerFrame = 0
		End If
	
		;Springen
		If KeyHit(KeyJu) And Jump = False Then JumpHigh# = 9:Jump = True
		
		;Stachelboden
		If Hit=False And Lives>0 Then
			If Map((PlayerX+20)/32, (PlayerY+32)/32, 0)=11 Or Map((PlayerX+4)/32, (PlayerY+32)/32, 0)=11 Then Lives = Lives-1:Hit = True
		End If
		
		;Sprung-Routine
		If Jump=True Then
			JumpHigh# = JumpHigh#-Graphity#
			PlayerY   = PlayerY-JumpHigh#
					
			If JumpHigh<=0 Then
				If Map((PlayerX+20)/32, (PlayerY+32)/32, 1)=1 Or Map((PlayerX+4)/32, (PlayerY+32)/32, 1)=1 Or Map((PlayerX+12)/32, (PlayerY+32)/32, 0)=8 Then
						
					;Wenn der Spieler zutief gefallen ist			
					If JumpHigh#<-20 Then Lives = Lives-1:Hit = True
					
					;Y Position auf der Map berechnen damit der Spieler nicht im Tile ist
					PlayerY       = PlayerY/32*32
					Jump 	  	  = False
					JumpHigh# 	  = 0
					PlayerXSpeed# = 0
				End If
			End If
		End If	
		
		;Wenn er mit dem Kopf an eine Tile knallt
		If PlayerY-20<=0 Or Map((PlayerX+20)/32, (PlayerY-18)/32, 1)=1 Or Map((PlayerX+4)/32, (PlayerY-18)/32, 1)=1 Then 
			PlayerY   = PlayerY+1
			JumpHigh# = 0
			Jump 	  = True
		End If
		
		;Wenn der Spieler im leeren steht, ihn fallen lassen
		If Map((PlayerX+25)/32, (PlayerY+32)/32, 0)<>8 And Map(PlayerX/32, (PlayerY+32)/32, 0)<>8 Then 
			If Map((PlayerX+25)/32, (PlayerY+32)/32, 1)=0 And Map(PlayerX/32, (PlayerY+32)/32, 1)=0 Then
				If OnPropeller=True And PlayerIsOnNoProp() Then OnPropeller = False			
				
				If OnPropeller=False And Jump=False Then 
					Jump = True
					JumpHigh# = 0
				End If
			End If
		End If
	End If
	
	;Map scrollen
	ScrX = PlayerX+12-400
	ScrY = PlayerY+ 8-300
	
	If ScrX<0 Then ScrX = 0 Else If ScrX>(MapMaxX+1)*32-800 Then ScrX = (MapMaxX+1)*32-800
	If ScrY<0 Then ScrY = 0 Else If ScrY>(MapMaxY+1)*32-600 Then ScrY = (MapMaxY+1)*32-600
	
	;Spieler zeichnen
	If Hit=True Then
		HitTimer = HitTimer-1
		If HitTimer = 0 Then HitTimer = 100:Hit = False
		If Not HitTimer Mod 2 Then DrawImage Player, PlayerX-ScrX, PlayerY-ScrY-17, PlayerFrame
	Else
		If Lives<=0 Then GameState = 5
		DrawImage Player, PlayerX-ScrX, PlayerY-ScrY-17, PlayerFrame
	End If
	
	;Wenn der Spieler das Ziel erreicht
	If RectsOverlap(PlayerX, PlayerY-17, 25, 49, FinishX, FinishY, 32, 32) And KeyHit(KeyNext) Then
		Level = Level+1
		ScrX = 0
		ScrY = 0
		If Level<=MaxLevel Then LoadMap(World(Level)) Else GameState = 7
	End If
End Function

;----------------------------------------------------------------------------------------------------------------------------------------------;

;kmmert sich um das Zwischenspeichern der Positionen und um das Zeit Zurckspulen
Function RenderBackUps()
	If GoBack=False Then
		
		;Damit es nicht zuviele BackUps werden den jeweils ersten lschen
		For B.BackUp=Each BackUp
			C = C+1
		Next
		
		If C>100 Then 	
			For I=0 To C-100
				B.BackUp = First BackUp
				Delete B
			Next
		End If
		
		;Eine neue Zwischenspeicherung anlegen		
		B.BackUp 	= New BackUp
		
		B\PlayerX 	    = PlayerX
		B\PlayerY 	    = PlayerY
		B\PlayerLives   = Lives
		B\PlayerPoints  = Points
		B\JumpHigh#     = JumpHigh
		B\Jump 		    = Jump
		B\PlayerSpeedX#	= PlayerXSpeed#
		B\PlayerFrame	= PlayerFrame
		
		;Mnzen Salmmel solange das Spiel vorwrts luft
		If Map((PlayerX+12)/32, (PlayerY+8)/32, 0)=5 Or Map((PlayerX+12)/32, (PlayerY+32)/32, 0)=5 Or Map((PlayerX+12)/32, (PlayerY-7)/32, 0)=5 Then 
			B\CoinFieldX = (PlayerX+12)/32
			
			If Map((PlayerX+12)/32, (PlayerY+ 8)/32, 0)=5 Then B\CoinFieldY = (PlayerY+ 8)/32
			If Map((PlayerX+12)/32, (PlayerY+32)/32, 0)=5 Then B\CoinFieldY = (PlayerY+32)/32
			If Map((PlayerX+12)/32, (PlayerY- 7)/32, 0)=5 Then B\CoinFieldY = (PlayerY- 7)/32
			
			Points 	  = Points+10
			Map(B\CoinFieldX, B\CoinFieldY, 0) = 0
		End If
		
		CurrBUN = CurrBUN+1
		If CurrBUN>100 Then CurrBUN = 100
	Else
		
		;Zum letzen eintrag wechseln
		B.BackUp = Last BackUp
		If B<>Null And CurrBUN>0 Then
			
			;Spielerdaten zurcksetzen
			PlayerX       = B\PlayerX
			PlayerY       = B\PlayerY
			Lives 	      = B\PlayerLives
			Points        = B\PlayerPoints
			JumpHigh# 	  = B\JumpHigh#
			Jump 	      = B\Jump
			PlayerXSpeed# = B\PlayerSpeedX#
			PlayerFrame	  = B\PlayerFrame
			
			;Setzt ein Coin-Feld zurck
			If B\CoinFieldX Or B\CoinFieldY Then Map(B\CoinFieldX, B\CoinFieldY, 0) = 5
						
			;Erstellt einen Gegner oder ein Flugkrper falls dieser gelscht wurde
			If B\EnemyX Or B\EnemyY Then
				If B\EnemyT<3 Then
					M.Missile = New Missile
					
					M\X = B\EnemyX
					M\Y = B\EnemyY
					M\D = B\EnemyD
					M\T = B\EnemyT
				Else
					E.Enemy = New Enemy
					
					E\X = B\EnemyX
					E\Y = B\EnemyY
					E\D = B\EnemyD
					E\T = B\EnemyT-3
				End If
			End If
			
			;Backup lschen, da er benutzt wurde :D
			Delete B
			CurrBUN = CurrBUN-1
		Else
			
			;Wenn der Eintrag nicht exestiert das Zurckspulen stoppen
			GoBack 	   = False 
			StopGoBack = True
		End If		
	End If
End Function